#pragma once

class CCharBuffer
{
public:
	CCharBuffer(size_t initialSize);
	virtual ~CCharBuffer(void);

	virtual operator char*() const			{ return m_buffer;		}
	virtual operator const char*() const	{ return m_buffer;		}
	virtual char& operator ()(int i) const	{ return m_buffer[i];	} 

	virtual bool checkSize(size_t suspectedSize);

	virtual size_t getSize() const { return m_size; }

	virtual void reset();

protected:
	char*	m_buffer;
	size_t	m_size;
};
